# Contributing

## Wiki

See (and edit!) our public Wiki.

https://github.com/shanalikhan/code-settings-sync/wiki/Contributing

I encourage you to create new pages or make helpful edits to all parts of the wiki. Try to ask before making major changes to pages you didn't create, but just do whatever you think is best. Feel free to make a user page and collect your notes there so everyone can learn.

## Slack

Join our public Slack:

<a href="https://join.slack.com/t/codesettingssync/shared_invite/enQtNzQyODMzMzI5MDQ3LWNmZjVkZjE2YTg0MzY1Y2EyYzVmYThmNzg2YjZkNjhhZWY3ZTEzN2I3ZTAxMjkwNWU0ZjMyZGFhMjdiZDI3ODU">
<img src="https://shanalikhan.github.io/img/slack.PNG" alt="Drawing" style="width: 50px;"/>
</a>

If you need any help or want someone to set up the workspace with you and get you stepping through code in your editor, make some noise in #contributors. Don't be afraid to speak up!

If you are looking forward to solve issues, you can select any issue you want but it would be great if you start with these issues, for these issues I will be specifically asking for help :

https://github.com/shanalikhan/code-settings-sync/labels/good%20first%20issue

https://github.com/shanalikhan/code-settings-sync/labels/PR-Welcome


## Setup Extension Locally

```
git clone https://github.com/shanalikhan/code-settings-sync.git
cd code-settings-sync
npm install
code .
```

Checkout the lastest version branch available and Hit `F5` to run Settings Sync in debug mode.

Git and Node should be enough to run this extension. Execute the commands above and you will be able to run the extension in Code.

**PR Base Branch Guideline:**
PR usually dont merge into `master` branch but in the version name branch like `v3.1.0`.
You will always see the next version branch if which current work is being done by me and other contributors. You need to set base branch and create PR for that branch.

## Run Tests
Make sure the changes you made are not breaking the tests cases!

All the test cases are in `/test` directory. Add new test cases if application with your PR.

To run the tests, 
1. `cd path/to/code-settings-sync && npm install && code .`
2. `Launch Extension` by pressing `F5`
3. From Debugger menu, start `Launch Tests`


## Bounty Programs - Fix and Earn !

There might be several issue present on the [IssueHunt](https://issuehunt.io/repos/47984369) from which you can earn money by fixing those issues. Feel free to start!



## Financial contributions

You can contribute me financially by two ways:

1. Sending donation directly to my PayPal

[<img src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif">](https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=4W3EWHHBSYMM8&lc=IE&item_name=Code%20Settings%20Sync&item_number=visual%20studio%20code%20settings%20sync&currency_code=USD&bn=PP%2dDonationsBF%3abtn_donate_SM%2egif%3aNonHosted)

2. If you looking forward to add some special features for your company, for this I also welcome financial contributions in full transparency on my [open collective](https://opencollective.com/code-settings-sync).

[![issuehunt-image](https://github.com/BoostIO/issuehunt-materials/blob/master/issuehunt-badge@1x.png?raw=true)](https://issuehunt.io/repos/47984369)


## Credits

### Contributors

Thank you to all the people who have already contributed to Settings Sync!
<a href="https://github.com/shanalikhan/code-settings-sync/graphs/contributors"><img src="https://opencollective.com/code-settings-sync/contributors.svg?width=890" /></a>

### Backers

Thank you to all our backers! [[Become a backer](https://opencollective.com/code-settings-sync#backer)]

<a href="https://opencollective.com/code-settings-sync#backers" target="_blank"><img src="https://opencollective.com/code-settings-sync/backers.svg?width=890"></a>

### Sponsors

Thank you to all our sponsors! (please ask your company to also support this open source project by [becoming a sponsor](https://opencollective.com/code-settings-sync/order/3849#))
